var $ = jQuery;

var page = {};

page['page-node-add-reservation'] = function () {
	'use strict';
	var updateTitle = function () {
		var val = $('#edit-field-member-und-0-uid').val().split(' [')[0],
			today = new Date().toISOString().slice(0, 10);
		$('#edit-title').val( val + ' ' + today);
	};

	$('#edit-field-member-und-0-uid').on('input', updateTitle);
	$('#edit-field-member-und-0-uid').on('change', updateTitle);
	$('#edit-field-member-und-0-uid').on('click', updateTitle);
	$(document).on('click', '#autocomplete', function () {
		setTimeout(updateTitle, 100);
	});

	$('#edit-field-member-und-0-uid').val(user.name).change();


	$('#edit-field-booking-und-sdate-datepicker-popup-0').on('change', function () {
		$('#edit-field-booking-date-und-0-value-datepicker-popup-0').val($(this).val());
	});
	$('#edit-field-booking-und-sdate-timeEntry-popup-1').on('change', function () {
		$('#edit-field-booking-date-und-0-value-timeEntry-popup-1').val($(this).val());
	});

	$('#edit-field-booking-und-edate-datepicker-popup-0').on('change', function () {
		$('#edit-field-booking-date-und-0-value2-datepicker-popup-0').val($(this).val());
	});
	$('#edit-field-booking-und-edate-timeEntry-popup-1').on('change', function () {
		$('#edit-field-booking-date-und-0-value2-timeEntry-popup-1').val($(this).val());
	});
	setTimeout(function () {
		$('#edit-field-booking-date-und-0-value-timeEntry-popup-1').val($('#edit-field-booking-und-sdate-timeEntry-popup-1').val());
		$('#edit-field-booking-date-und-0-value2-timeEntry-popup-1').val($('#edit-field-booking-und-edate-timeEntry-popup-1').val());
	}, 1000);

	page['page-node-add-resource']();
};

page['front'] = function () {
	'use strict';
	//console.log('called front page function');
	slider.init();
};

page['page-user-register'] = function () {
	'use strict';
	form.bootstrap();
	$('#edit-submit').removeClass('btn-info').addClass('btn-success');
};
page['page-member-edit'] = page['page-user-register'];

page['page-user-login'] = function () {
	'use strict';
	form.bootstrap();
};
page['page-user-edit'] = function () {
	'use strict';
	form.bootstrap();
	if (!$('body').hasClass('page-user-' + user.uid + '-edit')) {
		$('#edit-roles-3').parent().empty();
		$('body.logged-in.role-authenticated-user.role-monitor #edit-cancel,body.logged-in.role-authenticated-user.role-monitor #edit-timezone,body.logged-in.role-authenticated-user.role-monitor #edit-contact,body.logged-in.role-authenticated-user.role-monitor .form-item-name,body.logged-in.role-authenticated-user.role-monitor .form-item-mail,body.logged-in.role-authenticated-user.role-monitor .form-item-pass,body.logged-in.role-authenticated-user.role-monitor .form-item-status').empty();
	}
};
page['page-contact'] = function () {
	'use strict';
	form.bootstrap();
};
page['page-node-add-resource'] = function () {
	'use strict';
	form.bootstrap();
	$('#edit-submit').removeClass('btn-info').addClass('btn-success');
	$('#edit-preview').removeClass('btn-info').addClass('btn-warning');
	$('#edit-delete').removeClass('btn-info').addClass('btn-danger');
};

page['page-node-add-event-calendar'] = function () {
	'use strict';
	form.bootstrap();
	$('#edit-submit').removeClass('btn-info').addClass('btn-success');
	$('#edit-preview').removeClass('btn-info').addClass('btn-warning');
	$('#edit-delete').removeClass('btn-info').addClass('btn-danger');
};

page['page-node-add-meeting-minutes'] = function () {
	'use strict';
	form.bootstrap();
	$('#edit-submit').removeClass('btn-info').addClass('btn-success');
	$('#edit-preview').removeClass('btn-info').addClass('btn-warning');
	$('#edit-delete').removeClass('btn-info').addClass('btn-danger');
};

page['node-type-resource'] = page['page-node-add-resource'];
page['node-type-reservation'] = page['page-node-add-resource'];
page['node-type-event-calendar'] = page['page-node-add-resource'];
page['node-type-event-meeting-minutes'] = page['page-node-add-resource'];

page['page-inventory'] = function () {
	'use strict';
	$('table').addClass('table table-bordered table-hover');
};

page['page-calendar'] = function () {
	'use strict';
	if ($('body').hasClass('role-authenticated-user')) {
		setTimeout(function () {
			$('table.full tr td, table.mini tr td').off('click');
			/*$('table.full tr td, table.mini tr td').on('click', function (e) {
				e.preventDefault(); 
				e.stopPropagation();
				return false;
			});*/
		}, 1000);
	}
	if (user && 
		(user.flatAuth.indexOf('Monitor') !== -1 ||
		user.flatAuth.indexOf('authenticated user') !== -1 ||
		user.flatAuth.indexOf('administrator')  !== -1)) {
		$('#calendar-actions .btn-success').show();
	}
};
page['page-member-calendar'] = page['page-calendar'];
page['page-admin-content'] = function () {
	'use strict';
	var ext = [
		{ query : 'table', className: 'table table-striped table-bordered table-hover'}
	];
	form.bootstrap(ext);
};
page['page-member-tools'] = function () {
	'use strict';
	$('#profile_link').attr('href', '/member/' + user.uid + '/edit');
	$('#acct_link').attr('href', '/user/' + user.uid + '/edit');
};

page._runOnce = false;
page._init = function () {
	'use strict';
	var classes = $('body').attr('class').split(' '),
	i;
	if (!page._runOnce) {

		//ALL PAGES
		menu.init();

		for (i = 0; i < classes.length; i++) {
			if (typeof page[classes[i]] !== 'undefined') {
				page[classes[i]]();
			}
		}
		page._runOnce = true;
	}
};

var slider = {
	i : 0,
	elem : {},
	len : 0,
	fade: 500,
	delay : 5000,
	interval : null
};

slider.init = function () {
	'use strict';
	slider.elem = $('.view-id-home_page_carousel');
	slider.elem.find('img').addClass('img-responsive');
	slider.len = slider.elem.find('.views-row').size();
	slider.elem.on('click', slider.stop);
	slider.controls();
	slider.interval = setInterval(slider.advance, slider.delay);
	$(window).resize(slider.resize);
	slider.resize();
};

slider.controls = function () {
	'use strict';
	var i,	
		ul = $('<ul>').addClass('slider-controls'),
		li;
	slider.elem.append(ul);
	for (i = 0; i < slider.len; i++) {
		li = $('<li>').on('click', function () {
			var to = $(this).index(),
				from = slider.i;
			slider.change(from, to);
			slider.i = to;
		});
		if (i === 0) {
			li.addClass('active');
		}
		slider.elem.find('ul').append(li);
	}
};

slider.advance = function () {
	'use strict';
	var from = slider.i,
		to;
	slider.i += 1;
	if (slider.i === slider.len) {
		slider.i = 0;
	}
	to = slider.i;
	slider.change(from, to);
};

slider.change = function (from, to) {
	'use strict';
	var top = slider.elem.find('.views-row').eq(from),
		bottom = slider.elem.find('.views-row').eq(to);
	top.css('z-index', 10);
	bottom.css('z-index', 9).show();
	top.fadeOut(slider.fade);
	setTimeout(function () {
		$('.slider-controls li').removeClass('active');
		$('.slider-controls li').eq(to).addClass('active');
	}, slider.fade);
};

slider.stop = function () {
	'use strict';
	if (slider.interval !== null) {
		clearInterval(slider.interval);
		slider.interval = null;
	}
};

slider.resize = function () {
	'use strict';
	var w = $(window).width(),
		left = slider.elem.offset().left,
		h = w * (400 / 800),
		current = 0;

	if (w <= 752) {
		slider.elem.find('img').width(w).height('auto');
		slider.elem.width(w).height(h);
		slider.elem.find('.slider-controls').css('top', Math.round(h * .8) + 'px');
		if (left !== 0) {
			current = Math.round(slider.elem.css('margin-left').replace('px', ''));
			slider.elem.css('margin-left', current - left);
		}
	} else {
		slider.elem.attr('style', '');
		slider.elem.find('img').attr('style', '');
		slider.elem.find('.slider-controls').attr('style', '');
		slider.elem.css('margin-left', '0px');
	}
};

var menu = {};

menu.elem = {};
menu.nav = {};

menu.init = function () {
	'use strict';
	var ul = $('<ul>');

	menu.user();
	
	menu.elem = $('#sidebar');
	menu.nav = $('#navbar-menu');
	menu.userElem = $('#user_tools')
	ul.append($('#user-menu ul.menu').html());
	ul.append(menu.elem.find('.menu').eq(0).html());
	ul.append(menu.userElem.find('ul').html())
	menu.nav.append(ul);
	$('.navbar-toggle').on('click', menu.toggle);
};

menu.toggle = function () {
	'use strict';
	if (menu.nav.hasClass('expanded')) {
		menu.nav.removeClass('expanded');
	} else {
		menu.nav.addClass('expanded');
	}
};

menu.user = function () {
	'use strict';
	var auth = false;
	var monitor = false;
	var mail;
	var links;
	var elem = $('#user_tools');
	var keys = Object.keys(user.roles);
	var i;
	user.flatAuth = []
	for (i =0; i < keys.length; i++) {
		user.flatAuth.push(user.roles[keys[i]])
		if (user.roles[keys[i]] === 'authenticated user') {
			auth = true;
		}
		if (user.roles[keys[i]] === 'Monitor' || user.roles[keys[i]] === 'administrator') {
			monitor = true;
		}
	}

	if (auth) {
		elem.insertBefore($('#sidebar .block.last'));
		elem.show();
	}
	if (monitor) {
		elem.find('.monitor').show();
	}
};

var form = {};

form.bootstrap = function (extension) {
	'use strict';
	var i,
		elems = [
			{ query : 'form input[type=text]', className: 'form-control' },
			{ query : 'form input[type=email]', className: 'form-control'},
			{ query : 'form input[type=password]', className: 'form-control'},
			{ query : 'form textarea', className: 'form-control'},
			{ query : 'form select', className: 'form-control'},
			{ query : 'form input[type=checkbox]', className: 'form-control'},
			{ query : 'form input[type=radio]', className: 'form-control'},
			{ query : 'form input[type=submit]', className: 'btn btn-info'}
		];
	if (typeof extensions === 'undefined') extension = [];
	elems = elems.concat(extension);
	for (i = 0; i < elems.length; i++) {
		$(elems[i].query).each(function () { 
			$(this).addClass(elems[i].className); 
		});
	}
};


$(document).ready(page._init);